/*----- PROTECTED REGION ID(CumbiaTangoClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        CumbiaTangoClass.h
//
// description : Include for the CumbiaTango root class.
//               This class is the singleton class for
//                the CumbiaTango device class.
//               It contains all properties and methods which the 
//               CumbiaTango requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: giacomo $
//
// $Revision: 1.1 $
// $Date: 2017-03-14 13:11:06 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CumbiaTangoClass_H
#define CumbiaTangoClass_H

#include <tango.h>
#include <CumbiaAbstractDeviceClass.h>
#include <CumbiaTango.h>


/*----- PROTECTED REGION END -----*/	//	CumbiaTangoClass.h


namespace CumbiaTango_ns
{
/*----- PROTECTED REGION ID(CumbiaTangoClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	CumbiaTangoClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute double_scalar1 class definition
class double_scalar1Attrib: public Tango::Attr
{
public:
	double_scalar1Attrib():Attr("double_scalar1",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~double_scalar1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CumbiaTango *>(dev))->read_double_scalar1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CumbiaTango *>(dev))->write_double_scalar1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CumbiaTango *>(dev))->is_double_scalar1_allowed(ty);}
};

//	Attribute double_scalar2 class definition
class double_scalar2Attrib: public Tango::Attr
{
public:
	double_scalar2Attrib():Attr("double_scalar2",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~double_scalar2Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CumbiaTango *>(dev))->read_double_scalar2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CumbiaTango *>(dev))->write_double_scalar2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CumbiaTango *>(dev))->is_double_scalar2_allowed(ty);}
};


/**
 *	The CumbiaTangoClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  CumbiaTangoClass : public CumbiaAbstractDevice_ns::CumbiaAbstractDeviceClass
#else
class CumbiaTangoClass : public CumbiaAbstractDevice_ns::CumbiaAbstractDeviceClass
#endif
{
	/*----- PROTECTED REGION ID(CumbiaTangoClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	CumbiaTangoClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static CumbiaTangoClass *init(const char *);
		static CumbiaTangoClass *instance();
		~CumbiaTangoClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		CumbiaTangoClass(string &);
		static CumbiaTangoClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	CumbiaTango_H
