/*----- PROTECTED REGION ID(CumbiaTangoStateMachine.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: CumbiaTangoStateMachine.cpp,v 1.1 2017-03-14 13:11:06 giacomo Exp $";
//=============================================================================
//
// file :        CumbiaTangoStateMachine.cpp
//
// description : State machine file for the CumbiaTango class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: giacomo $
//
// $Revision: 1.1 $
// $Date: 2017-03-14 13:11:06 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <CumbiaTango.h>

/*----- PROTECTED REGION END -----*/	//	CumbiaTango::CumbiaTangoStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace CumbiaTango_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CumbiaTango::is_double_scalar1_allowed()
 *	Description : Execution allowed for double_scalar1 attribute
 */
//--------------------------------------------------------
bool CumbiaTango::is_double_scalar1_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for double_scalar1 attribute in Write access.
	/*----- PROTECTED REGION ID(CumbiaTango::double_scalar1StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CumbiaTango::double_scalar1StateAllowed_WRITE

	//	Not any excluded states for double_scalar1 attribute in read access.
	/*----- PROTECTED REGION ID(CumbiaTango::double_scalar1StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CumbiaTango::double_scalar1StateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CumbiaTango::is_double_scalar2_allowed()
 *	Description : Execution allowed for double_scalar2 attribute
 */
//--------------------------------------------------------
bool CumbiaTango::is_double_scalar2_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for double_scalar2 attribute in Write access.
	/*----- PROTECTED REGION ID(CumbiaTango::double_scalar2StateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CumbiaTango::double_scalar2StateAllowed_WRITE

	//	Not any excluded states for double_scalar2 attribute in read access.
	/*----- PROTECTED REGION ID(CumbiaTango::double_scalar2StateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CumbiaTango::double_scalar2StateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================


/*----- PROTECTED REGION ID(CumbiaTango::CumbiaTangoStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	CumbiaTango::CumbiaTangoStateAllowed.AdditionalMethods

}	//	End of namespace
